﻿using System;

namespace DecoratedBook
{
    public class Book : IBook, IEquatable<IBook>
    {
        public String Author { get; set; }
        public String Title { get; set; }
        public int YearOfPublication { get; set; }

        public override string ToString()
        {
            return string.Format("{0} : {1}, {2}", Author, Title, YearOfPublication);
        }

        public bool Equals(IBook other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return string.Equals(Author, other.Author) && string.Equals(Title, other.Title) && YearOfPublication == other.YearOfPublication;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            //if (obj.GetType() != this.GetType()) return false;
            if (!(obj is IBook)) return false;
            return Equals((IBook) obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int hashCode = (Author != null ? Author.GetHashCode() : 0);
                hashCode = (hashCode*397) ^ (Title != null ? Title.GetHashCode() : 0);
                hashCode = (hashCode*397) ^ YearOfPublication;
                return hashCode;
            }
        }
    }
}