﻿using System;

namespace DecoratedBook
{
    public class UnmodifiableBook : IBook
    {
        private readonly IBook _book;

        public UnmodifiableBook(IBook book)
        {
            if (book == null) throw new ArgumentNullException("book");
            _book = book;
        }

        public string Author
        {
            get { return _book.Author; }
            set { throw new NotSupportedException("Book object is unmodifiable"); }
        }

        public string Title
        {
            get { return _book.Title; }
            set { throw new NotSupportedException("Book object is unmodifiable"); }
        }

        public int YearOfPublication
        {
            get { return _book.YearOfPublication; }
            set { throw new NotSupportedException("Book object is unmodifiable"); }
        }

        public override string ToString()
        {
            return _book.ToString();
        }

        public override bool Equals(object obj)
        {
            return _book.Equals(obj);
        }

        public override int GetHashCode()
        {
            return _book.GetHashCode();
        }
    }
}
