﻿using System;
using DecoratedBook;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DecoratedBookTests1
{
    [TestClass]
    public class ThreadSafeBookTests
    {
        [TestMethod]
        public void TestItAll()
        {
            IBook ordinaryBook = new Book
            {
                Author = "Sturm",
                Title = "Functional Programming in C#",
                YearOfPublication = 2011
            };
            IBook safeBook = new ThreadSafeBook(ordinaryBook);
            Assert.AreEqual("Sturm", safeBook.Author);
            safeBook.Author = "Anders";
            Assert.AreEqual("Anders", safeBook.Author);
            Assert.AreEqual("Anders", ordinaryBook.Author);

            Assert.AreEqual("Functional Programming in C#", safeBook.Title);
            safeBook.Title = "My best book";
            Assert.AreEqual("My best book", safeBook.Title);
            Assert.AreEqual("My best book", ordinaryBook.Title);

            Assert.AreEqual(2011, safeBook.YearOfPublication);
            safeBook.YearOfPublication = 2008;
            Assert.AreEqual(2008, safeBook.YearOfPublication);
            Assert.AreEqual(2008, ordinaryBook.YearOfPublication);

            try
            {
                new ThreadSafeBook(null);
                Assert.Fail();
            }
            catch (ArgumentNullException) { /* empty */}

        }
    }
}
